var DatePicker = new Object();

DatePicker.formatDate = function(format, date) {
	var bits = {};
    bits['d'] = date.getDate();
    bits['dd'] = DatePicker.pad(date.getDate(),2);
    bits['ddd'] = this._shortWeekDayNames[date.getDay()];
    bits['dddd'] = this._weekDayNames[date.getDay()];
	
    bits['M'] = date.getMonth()+1;
    bits['MM'] = DatePicker.pad(date.getMonth()+1,2);
    bits['MMM'] = this._shortMonthNames[date.getMonth()];
    bits['MMMM'] = this._monthNames[date.getMonth()];
    
    var yearStr = "" + date.getFullYear();
    yearStr = (yearStr.length == 2) ? '19' + yearStr: yearStr;
    bits['yyyy'] = yearStr;
    bits['yy'] = bits['yyyy'].toString().substr(2,2);
    
    // do some funky regexs to replace the format string
    // with the real values
    if(!format) format = "yyyy-MM-dd";
    var frm = new String(format);
    var sect;
    for (sect in bits) {
    	  if (sect == "extend") continue;
      frm = eval("frm.replace(/\\b" + sect + "\\b/,'" + bits[sect] + "');");
    }
    
    return frm;
}

DatePicker._monthNames = [    
    "January",      "February",     "March",    "April",
    "May",          "June",         "July",     "August",
    "September",    "October",      "November", "December"
];

DatePicker._shortMonthNames = [ 
    "jan", "feb", "mar", "apr", "may", "jun", 
    "jul", "aug", "sep", "oct", "nov", "dec"
];

// Week days start with Sunday=0, ... Saturday=6
DatePicker._weekDayNames = [
    "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday" 
];

DatePicker._shortWeekDayNames = 
    ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat" ];

DatePicker.showPicker = function(elementId, pickerName) {
	var block = document.getElementById(elementId);
	var picker;
	if (!block) {
	    var body = document.body;
	    block = document.createElement("div");
	    block.setAttribute("id", elementId);
	    block.style.display = "block";
	    block.style.position = "absolute";
	    block.style.zIndex = "400";
	    block.style.background = "Window";
	    block.style.backgroundColor = "#ffffff";
	    block.style.borderColor = "#aaaaaa";
	    block.style.borderStyle = "solid";
	    block.style.borderWidth = "2px";
	    block.style.width = "18.1em";
	    var inputField = document.getElementById(pickerName);
        var offsets = DatePicker.cumulativeOffset(inputField);
        block.style.top    = offsets[1] + 15 + 'px';
        block.style.left   = offsets[0] + 'px';
        body.appendChild(block);
        
	    picker = dojo.widget.createWidget("DatePicker", 
                {widgetId: pickerName + "Picker"}, block, "last");
	} else 
	    picker = dojo.widget.byId(pickerName + "Picker");
	    
    dojo.fx.html.fadeShow(block, 200);
    return picker;
}

DatePicker.pad = function(number,X) {   // utility function to pad a number to a given width
    X = (!X ? 2 : X);
    number = ""+number;
    while (number.length < X) {
        number = "0" + number;
    }
    return number;
}

DatePicker.cumulativeOffset = function(element) {
    var valueT = 0, valueL = 0;
    do {
      valueT += element.offsetTop  || 0;
      valueL += element.offsetLeft || 0;
      element = element.offsetParent;
    } while (element);
    return [valueL, valueT];
}