var tacos_global = this;

function tacos_undef(name, obj)
{
    if (!obj) {
        obj = tacos_global;
    }
    return (typeof obj[name] == "undefined");
}

if (tacos_undef("tacosConfig")) {
    tacos_global["tacosConfig"] = {};
}
var tacosConfig;
tacosConfig.defaultExceptionConsoleId = "exceptionId";
tacosConfig.popupWhenException = true;

//
// Enables wait cursor on requests
//
var BoilerPlate = new Object();
BoilerPlate.Cursor = {
    setCursor: function(cursor)
    {
        BoilerPlate.Cursor.resetCursor();
        document.body.style.cursor = cursor;
    },

    setElementCursor: function(element, cursor)
    {
        if (!element || typeof element.style == "undefined")
            return;

        if (!this.cursorQueue) {
            this.cursorQueue = [];
        }
        this.cursorQueue.push(element);
        element.style.cursor = cursor;
    },

    resetCursor: function()
    {
        document.body.style.cursor = "auto";
        if (this.cursorQueue) {
            for (var i = 0; i < this.cursorQueue.length; i++) {
                if (this.cursorQueue[i]) {
                    this.cursorQueue[i].style.cursor = "auto";
                }
            }

            this.cursorQueue = null;
        }
    }
};

//
// Core tacos library
//
var tacos = new Object();
tacos.forms = {};
tacos.processInFlight = false;

tacos.cumulativeOffset = function(element) {
    var valueT = 0, valueL = 0;
    do {
      valueT += element.offsetTop  || 0;
      valueL += element.offsetLeft || 0;
      element = element.offsetParent;
    } while (element);
    return [valueL, valueT];
}

tacos.getContentAsStringOld = function(elem) {
	var returnVal = '';

	if (typeof elem == 'string') {
		returnVal = elem;
	} else if (typeof elem == 'undefined') {
		returnVal = elem;
	} else if (elem.innerText) {
		returnVal = elem.innerText;
	} else {
		var cs = elem.childNodes;
		for (var i=0; i < cs.length; i++)
			switch (cs[i].nodeType) {
				case 1: //ELEMENT NODE
					returnVal += XBinnerText(cs[i]);
					break;
				case 3: //TEXT NODE
					returnVal += cs[i].nodeValue;
					break;
			}
	}

	return returnVal;
}

tacos.getContentAsString = function(parentNode)
{
	dojo.debug("getContentAsString() ");
	dojo.debug("parentNode.xml: " + parentNode.xml);
	if (typeof parentNode.xml != "undefined")
		return tacos._getContentAsStringIE(parentNode);
	else if (typeof XMLSerializer != "undefined" )
		return tacos._getContentAsStringMozilla(parentNode);
	else
		return tacos._getContentAsStringGeneric(parentNode);
	
    //return (typeof parentNode.xml != 'undefined') ?
      //     tacos._getContentAsStringGeneric(parentNode) :
        //   tacos._getContentAsStringMozilla(parentNode);
}

tacos._getContentAsStringIE = function(parentNode)
{
    var contentStr = "";
    for (var i = 0; i < parentNode.childNodes.length; i++)
        contentStr += parentNode.childNodes[i].xml;
    return contentStr;
}

tacos._getContentAsStringMozilla = function(parentNode)
{
    var xmlSerializer = new XMLSerializer();
    var contentStr = "";
    for (var i = 0; i < parentNode.childNodes.length; i++) {
        contentStr += xmlSerializer.serializeToString(parentNode.childNodes[i]);
        if (contentStr == "undefined") {
	        return tacos._getContentAsStringGeneric(parentNode);	        
	    }
    }
    // fix textareas for mozilla
    contentStr = tacos.fixTextarea(contentStr);
    return contentStr;
}

tacos._getContentAsStringGeneric = function(node){
	var _result = "";
	if (node == null) { return _result; }
	for (var i = 0; i < node.childNodes.length; i++) {
		var thisNode = node.childNodes[i];
		switch (thisNode.nodeType) {
			case 1: // ELEMENT_NODE
			case 5: // ENTITY_REFERENCE_NODE
				_result += tacos._getElementAsStringGeneric(thisNode);
				break;
			case 3: // TEXT_NODE
			case 2: // ATTRIBUTE_NODE
			case 4: // CDATA_SECTION_NODE
				_result += thisNode.nodeValue;
				break;
			default:
				break;
		}
	}
	return _result;	
}

tacos._getElementAsStringGeneric = function(thisNode){
	var _result = "";
	if (thisNode == null) { return _result; }
	// start tag
	_result += '<' + thisNode.nodeName;
	// add attributes
	if (thisNode.attributes && thisNode.attributes.length>0) {
		for (var i = 0; i < thisNode.attributes.length; i++) {
			_result += " " + thisNode.attributes[i].name 
				+ "=\"" + thisNode.attributes[i].value + "\"";	
		}
	}
	// close start tag
	_result += '>';
	// content of tag
	_result += tacos._getContentAsStringGeneric(thisNode);
	// end tag
	_result += '</' + thisNode.nodeName + '>';
	return _result;
}

//Regexp matcher for javascript blocks in html content
tacos.TextareaMatcher = '<textarea(.*?)/>';

tacos.fixTextarea = function(contentStr)
{
	var match = new RegExp(tacos.TextareaMatcher);
	contentStr = contentStr.replace(match, "<textarea$1></textarea>");
	
	if (contentStr.match(match))
		return tacos.fixTextarea(contentStr);
	else
		return contentStr;
}

//
// Checks for existance of proper response and attempts to do default
// error handling if the response looks invalid.
//
tacos.loadDojoResponse = function(type, data, request, kwArgs)
{
    var response = data.getElementsByTagName("ajax-response");
    // Handle errors..if no ajax-response nodes but there is data
    // then it is probably a server redirect or exception page
    if (response == null || response.length < 1) {
        tacos.responseComplete(data);
        dojo.debug("Received response, but had no elements of type ajax-response or the xml returned is not well-formed");
        dojo.debug("Response: " + request.responseText);
        setTimeout(function() {
          document.writeln(request.responseText);
          BoilerPlate.Cursor.resetCursor();
        }, 20);
        return false;
    }
	
    if (kwArgs["processScripts"]) {
      var remNodes = new Array();
        var responseNodes = response[0].childNodes;
        //If js includes exist, need to evaluate them first
        for (var i = 0; i < responseNodes.length; i++) {
            var responseElement = responseNodes[i];
			
            // only process nodes of type element.....
            if (responseElement.nodeType != 1)
                continue;
			
            var responseId = responseElement.getAttribute("id");
            var responseType = responseElement.getAttribute("type");
            dojo.debug("preProcessScripts id:" + responseId);
            if (responseId == "jsincludes" || responseId == "preprocess") {
                var incontent = tacos.getContentAsString(responseElement);
                tacos.processScripts(incontent, false);
				
                remNodes.push(responseElement);
            }
        }
		
        //remove nodes already processed
        for (var i = 0; i < remNodes.length; i++) {
          dojo.dom.removeNode(remNodes[i]);
        }
    }
	
    tacos.processAjaxResponse(response[0].childNodes, kwArgs);
    return true;
}

dojo.require("dojo.fx.html");

//
// Main entry point for ajax-response processing of a response
// after it has been determined to be valid and complete
//
tacos.processAjaxResponse = function (xmlResponseElements, kwArgs)
{

    for (var i = 0; i < xmlResponseElements.length; i++) {
        var responseElement = xmlResponseElements[i];
		
        // only process nodes of type element.....
        if (responseElement.nodeType != 1)
            continue;
		
        var responseType = responseElement.getAttribute("type");
        var responseId = responseElement.getAttribute("id");
        if (responseType == "element" && responseId != "scriptblock"
        		&& responseId != "postprocess") {
			
            dojo.debug("processAjaxResponse responseId:" + responseId);
            var cancelProcessing = false;
            //Call optional updateObject beforeAjaxUpdate
            if (kwArgs["updateObject"]
                    && typeof kwArgs["updateObject"].beforeAjaxUpdate != "undefined")
                cancelProcessing = kwArgs["updateObject"].beforeAjaxUpdate(responseElement, responseId);
			
            //replace element contents
            if (!cancelProcessing) {
                tacos.loadElement(responseElement, responseId, kwArgs);
            }
        } else if (responseType == "statustext") {
            //if they specified their own status update area
            if (kwArgs["statusElement"]) {
                var statusElement = document.getElementById(kwArgs["statusElement"]);
                if (!statusElement) continue;
                statusElement.innerHTML = tacos.getContentAsString(responseElement);
                //animation
                dojo.fx.html.fadeShow(statusElement, 100, function()
                {
                    setTimeout(function()
                    {
                        dojo.fx.html.fadeHide(statusElement, 400);
                    }, 2000);
                });
            }
        } else if (responseType == "exception") {
            tacos.handleException(responseElement);
            dojo.debug("after handle exception!");
        }
    }
	
	//postprocessing scripts
	if (kwArgs["processScripts"]) {
      var remNodes = new Array();
        //If js includes exist, need to evaluate them first
        for (var i = 0; i < xmlResponseElements.length; i++) {
            var responseElement = xmlResponseElements[i];
			
            // only process nodes of type element.....
            if (responseElement.nodeType != 1)
                continue;
			
            var responseId = responseElement.getAttribute("id");
            var responseType = responseElement.getAttribute("type");
            dojo.debug("postProcessScripts id:" + responseId);
            if (responseId == "postprocess") {
                var incontent = tacos.getContentAsString(responseElement);
                tacos.processScripts(incontent, true);
				
                remNodes.push(responseElement);
            }
        }
		
        //remove nodes already processed
        for (var i = 0; i < remNodes.length; i++) {
          	dojo.dom.removeNode(remNodes[i]);
        }
    }
	
    //Call optional updateObject
    if (kwArgs["updateObject"]
            && typeof kwArgs["updateObject"].responseComplete != "undefined")
        kwArgs["updateObject"].responseComplete(xmlResponseElements);
    tacos.responseComplete(xmlResponseElements);
}

//
// Called to process an individual ajax-response element
//
tacos.loadElement = function(responseElement, responseId, kwArgs)
{
    var contents;
    if (responseElement.childNodes && responseElement.childNodes.length > 0) {
        for (var i = 0; i < responseElement.childNodes.length; i++) {
            var node = responseElement.childNodes[i];
            if (node.nodeType != 1) continue;
			
            var nodeId = node.getAttribute("id");
            if (nodeId && nodeId == responseId) {
                contents = node;
                break;
            }
        }
    } else {
        contents = responseElement;
    }
    if (dojo.byId(responseId)) {
        var localElement = dojo.byId(responseId);
		
        dojo.debug("responseId: " + responseId);
        localElement.innerHTML = tacos.getContentAsString(contents);
		
        //Process effects parameters
        if (kwArgs["effects"]) {
            tacos.processEffects(responseId, kwArgs["effects"]);
        }

        if (kwArgs["popup"]) {
            kwArgs["popup"].content = localElement.innerHTML;
            dojo.debug("popup content: " + kwArgs["popup"].content);
            tacos.processPopup(responseId, kwArgs["popup"]);
        }

        //Call optional updateObject
        if (kwArgs["updateObject"] && responseId != "scriptblock"
                && typeof kwArgs["updateObject"].ajaxUpdate != "undefined")
            kwArgs["updateObject"].ajaxUpdate(responseElement, localElement, responseId);
    }
}

//
//List all the effects that tacos supported.
//
tacos.supportedEffects = {
    highlight: "dojo.fx.html.highlight(effectElement, effectArguments)",
    fadeshow:  "dojo.fx.html.fadeShow(effectElement, effectArguments)",
    fadehide:  "dojo.fx.html.fadeHide(effectElement, effectArguments)",
    fade  :  "dojo.fx.html.fade(effectElement, effectArguments)",
    wipein  :  "dojo.fx.html.wipeIn(effectElement, effectArguments)",
    wipeout  :  "dojo.fx.html.wipeOut(effectElement, effectArguments)",
    explode  :  "dojo.fx.html.explode(effectArguments)",
    implode  :  "dojo.fx.html.implode(effectArguments)"
}

//
// Called to process supported effects
//
tacos.processEffects = function(responseId, effectArgs)
{
  var elmid = "dojo.byId(" + dojo.lang.reprString(responseId) + ")";
    dojo.debug("processEffects(" + responseId + ")");
    for (effectName in tacos.supportedEffects) {
        if (!effectArgs[effectName]) {
            continue;
        }
        var executed = tacos.supportedEffects[effectName];
        if (effectArgs[effectName][responseId]) {
            executed = executed.replace("effectArguments", effectArgs[effectName][responseId]);
            executed = executed.replace("effectElement", elmid);
            dojo.debug("processEffects(" + responseId + ") effect is:" + executed);
            eval(executed);
        } else if (effectArgs[effectName]["any"]) {
            executed = executed.replace("effectArguments", effectArgs[effectName]["any"]);
            executed = executed.replace("effectElement", elmid);
            dojo.debug("processEffects(" + responseId + ") ANY effect is:" + executed);
            eval(executed);
        } else {
          dojo.debug("processEffects(" + responseId + ") can't find matching effect for response");
        }
    }
}

//
// Last method called when response is completely processed
//
tacos.responseComplete = function(xmlResponseElements)
{
    BoilerPlate.Cursor.resetCursor();
}

//
// Core method called to initiate ajax request
//
tacos.defaultLinkAction = function(kwArgs)
{
    BoilerPlate.Cursor.setCursor("wait");
    if (kwArgs["targetLink"]) BoilerPlate.Cursor.setElementCursor(kwArgs["targetLink"], "wait");
    if (!kwArgs["content"]) kwArgs["content"] = {};
    kwArgs["content"]["dojoRequest"] = "true";
    kwArgs["content"]["processScripts"] = kwArgs["processScripts"];
    kwArgs["content"]["uuid"] = new Date();
    kwArgs["content"]["widgetids"] = dojo.widget.manager.widgetIds.join(",");
    dojo.io.bind({
        url: kwArgs["url"],
        content: kwArgs["content"],
        load: function(type, data, evt)
        {
            if (djConfig["isDebug"]) {
                dojo.info("Response:" + evt.responseText);
            }
            if (tacos.loadDojoResponse(type, data, evt, kwArgs)) {
              if (kwArgs["processScripts"] && data) {
                  tacos.processScripts(tacos.getContentAsString(
                          data.getElementsByTagName("ajax-response")[0]),
                          true);
              }
            }
        },
        error: function(type, error)
        {
            dojo.debug("Received error response of:" + error);
            tacos.responseComplete();
            document.clear();
            document.writeln(error);
        },
        sync: kwArgs["useSync"],
        mimetype: "text/xml",
        encoding: "UTF-8"
    });
    return false;
}

//
// Function for submitting a tapestry form
//
tacos.formSubmit = function(kwArgs)
{
    BoilerPlate.Cursor.setCursor('wait');

    if (!kwArgs["content"]) {
        kwArgs["content"] = { dojoRequest: "true",
            processScripts: kwArgs["processScripts"]};
    }

  //Experimental
  kwArgs["content"]["widgetids"] = dojo.widget.manager.widgetIds.join(",");
  dojo.debug("visible widgets set to:" + kwArgs["content"]["widgetids"]);

    //Actual IO call to submit the form
    dojo.io.bind({
        url: kwArgs["url"],
        content: kwArgs["content"],
        formNode: document.getElementById(kwArgs["formId"]),
        load: function(type, data, evt)
        {
        	if (kwArgs["multipart"]) {
        		dojo.debug("Multipart data submit response received.");
        		//Call optional updateObject
			    if (kwArgs["updateObject"]
			            && typeof kwArgs["updateObject"].responseComplete != "undefined")
			        kwArgs["updateObject"].responseComplete(data);
          			tacos.responseComplete(data);
        		return;
        	}
            if (tacos.loadDojoResponse(type, data, evt, kwArgs)) {
              if (djConfig["isDebug"]) {
                  dojo.info("FormResponse:" + evt.responseText);
              }
              if (kwArgs["processScripts"] && data) {
                  tacos.processScripts(tacos.getContentAsString(
                          data.getElementsByTagName("ajax-response")[0]),
                          true);
              }
            }
        },
        backButton: function()
        {
            if (kwArgs["backLink"])
                eval(kwArgs["backLink"]);
        },
        forwardButton: function()
        {
            if (kwArgs["forwardLink"])
                eval(kwArgs["forwardLink"]);
        },
        error: function(type, error)
        {
            dojo.debug("Received error response of type "
                  + type + " with error " + error.message);
            tacos.responseComplete();
        },
        mimetype: "text/xml",
        encoding: "UTF-8",
        method: "post",
        multipart: kwArgs["multipart"]
    });
    return false;
}

//Regexp matcher for javascript blocks in html content
tacos.ScriptFragment = '(?:<script.*?>)((\n|.|\r)*?)(?:<\/script>)';

//
// Evals <Script> contents of a returned respnose.
//
// text - The text string to check for scripts
// async - Whether to process the scripts synchronously or
//       asynchronously (ie on seperate thread)
//
tacos.processScripts = function(text, async)
{
	dojo.debug("processScripts");
	//if still processing another script come back
	if (tacos.processInFlight) {
		dojo.debug("processInFlight is true, sleeping");
		setTimeout(function() {
			tacos.processScripts(text, async);
		}, 5);
		return;
	}
	dojo.debug("processScripts executing with processInFlight value:" + tacos.processInFlight);

    var match = new RegExp(tacos.ScriptFragment, 'img');
    var response = text.replace(match, '');
    var scripts = text.match(match);
	
    if (scripts) {
        match = new RegExp(tacos.ScriptFragment, 'im');
        if (async) {
            setTimeout(function()
            {
            		tacos.processInFlight = true;
                for (var i = 0; i < scripts.length; i++) {
                    var scr = scripts[i].match(match)[1];
                    try {
                        dojo.debug("evaluating script:" + scr);
                        eval(scr);
                    } catch (e) {
                        dojo.debug(e + " with script:" + scr);
                    }
                }
                tacos.processInFlight = false;
            }, 60);
        } else {
        		tacos.processInFlight = true;
            for (var i = 0; i < scripts.length; i++) {
                try {
                    var scr = scripts[i].match(match)[1];
                    dojo.debug("sync script eval of:" + scr);
                    eval(scr);
                } catch (e) {
                    dojo.debug("ERROR: processing script:" + e);
                }
            }
            tacos.processInFlight = false;
        }
    }
}

//
// Utility that returns nothing for <a href="javascript:tacos.noReturn();"></a> links.
//
tacos.noReturn = function()
{
}

//
// Loads a js package from the specified url
//
tacos.loadScriptFromUrl = function(url)
{
    //dojo.hostenv.loadUri(url);
    var scripts = window.document.getElementsByTagName("script");
    for (var i = 0; i < scripts.length; i++) {
        var src = scripts[i].src;
        if (src && src.length > 0 && src == url) {
            return;
        }
    }

    var e = document.createElement("script");
    e.src = url;
    e.type = "text/javascript";
    document.getElementsByTagName("head")[0].appendChild(e);
}

//
// Utility that manages the creation of dojo
// FisheyeList widgets.
// ajax - Boolean, if true then content is coming from
//       an ajax response
// fishIds - Array of unique widget ids of each fisheye that needs building
// fishProps - Structure of properties to be used to build each
//            FisheyeList, the property set for a specific fisheye
//           is stored under fishProps[fishId].
//
tacos.buildFisheye = function(ajax, fishIds, fishProps)
{
    
    if (ajax) {
	    for (var i = 0; i < fishIds.length; i++) {
	        var fishEye = dojo.widget.byId(fishIds[i]);
	        //if ajax request we have to build it manually
	        if (ajax) {
	            dojo.debug("Creating fisheye with fishId:" + fishIds[i]);
	            djConfig.searchIds.push(fishIds[i]);
	            /* var fnode = dojo.byId(fishIds[i]);
	            dojo.debug("Fisheye dom node for " + fishIds[i] + " exists?:" + (fnode != null));
	            if (!fnode) {
	                dojo.debug("ERROR: Cant find old fisheye");
	                continue;
	            }
				
	            fishEye = dojo.widget.fromScript("FisheyeList",
	                    fishProps[fishIds[i]], fnode);
	            if (!fishEye) {
	                dojo.debug("ERROR: Unable to create FisheyeList with id:" + fishIds[i]);
	                return;
	            }
	            
	            dojo.html.body().appendChild(fishEye.domNode);
	            */
	        }     
	   }
	   
	   dojo.widget.widgetIds = [];
	   dojo.hostenv.makeWidgets();
	   dojo.hostenv.searchIds = [];
   } 
   for (var i = 0; i < fishIds.length; i++) {
   var fishEye = dojo.widget.byId(fishIds[i]);
   if (!fishEye) {
   	dojo.debug("ERROR: Unable to find fisheye with id:" + fishIds[i]);
   	continue;
   }
        //Fix element ids
        for (var e = 0; e < fishEye.children.length; e++) {
            var item = fishEye.children[e];
            if (item && item.domNode) {
                item.domNode.setAttribute("id", item.widgetId);
            } else {
              dojo.debug("item domNodeid: " + dojo.html.getAttribute(item.domNode, "id"));
                dojo.debug("Fisheye element doesn't have srcDiv or id attribute");
            }
        }
    }
}

//
// Attempts to build a dojo Dialog widget on the fly
//
tacos.buildDialog = function(ajax, elementId, hidden)
{
	dojo.require("dojo.widget.Manager");
	if (ajax) {
	    var cdialog = dojo.widget.byId(elementId);
		var node = dojo.byId(elementId);
		
		//if already exists
		if (cdialog) {
			cdialog.domNode.innerHTML = node.innerHTML;
		  	if (hidden)
		  		cdialog.hide();
		  		
		  	dojo.dom.removeNode(node);
		  	return;
		}
		
		if (!node) {
		    dojo.debug("ERROR: Cant find dialog node with id:" + elementId);
		    return;
		}
		
		node.style.display = "none";
		cdialog = dojo.widget.fromScript("Dialog",
		          {id:elementId, widgetId:elementId}, node);
		dojo.widget.manager.widgetIds.push(elementId);
		if (!cdialog) {
		    dojo.debug("ERROR: Unable to create Dialog with id:" + elementId);
		    return;
		}
		
		if (!hidden)
			cdialog.show();
  	} else {
    		var cdialog = dojo.widget.byId(elementId);
      	if (cdialog) {
          dojo.widget.manager.widgetIds.push(elementId);
          
          if(!hidden)
          	cdialog.show();
      	} else {
      		//need to build it
      		var node = dojo.byId(elementId);
      		node.style.display = "none";
			cdialog = dojo.widget.fromScript("Dialog",
		          {id:elementId, widgetId:elementId}, node);
			dojo.widget.manager.widgetIds.push(elementId);
			if (!hidden)
				cdialog.show();
      	}
  	}
}

tacos.processPopup = function(responseId, popupArgs){
	
//    if(!popupArgs.contentNodeId){
//        popupArgs.contentNodeId = responseId;
//    }
    if(popupArgs.contentNodeId !=responseId){
        return;
    }
    tacos.showPopupPane(popupArgs);
}

//
// handle the exception during any ajax request.
//
// Builds a floating exception window on error response, if
// the node with id tacosConfig.defaultExceptionConsoleId already exists, it's content
// will be targeted with the exception, otherwise a new node
// will be appended to the body.
//
// If a new node is created it will have a class attribute of
// "exception".
//
// htmlContent - String parsed html content response, will be
//				set on html node as innertHTMl
//
tacos.handleException = function(responseElement)
{
    if (!tacosConfig.popupWhenException) {
        dojo.debug("just replace defaultExceptionConsoleId's content with exception page!");
        var exceptionNode = dojo.byId(tacosConfig.defaultExceptionConsoleId);
        if(!exceptionNode){
            exceptionNode = document.createElement("div");
            exceptionNode.setAttribute("id",tacosConfig.defaultExceptionConsoleId);
            dojo.html.body().appendChild(exceptionNode);
        }
        exceptionNode.innerHTML = tacos.getContentAsString(responseElement);

    } else {

        dojo.debug("exception pane will be shown.");
        var fpArgs = {
            title:"Server Exception",
            widgetId:"exception",
            constrainToContainer:"1",
            toggle:'fade',
            resizable:true,

            persistenceWidgetPosition: true,
            //class:'exception',
            contentNodeId: tacosConfig.defaultExceptionConsoleId,
            content: tacos.getContentAsString(responseElement)
        }
        tacos.showPopupPane(fpArgs);
    }
}

//
// Show an Popup pane.
//
tacos.showPopupPane = function(floatingPaneArgs)
{

    dojo.require("dojo.widget.FloatingPane");
    dojo.require("dojo.widget.ResizeHandle");
    dojo.require("dojo.widget.LayoutPane");
    dojo.require("dojo.dom");
    
    if(!floatingPaneArgs["widgetId"] || (floatingPaneArgs["contentNodeId"] ==floatingPaneArgs["widgetId"])){
        floatingPaneArgs["widgetId"] = floatingPaneArgs["contentNodeId"] + "WidgetId";
        dojo.debug("widgetId isn't provided or is the same with contentNodeId!, using '"+floatingPaneArgs["widgetId"] + "' as widgetId");
    }
	
    var fpwidget = dojo.widget.getWidgetById(floatingPaneArgs["widgetId"]);
	
    var contentNode = dojo.byId(floatingPaneArgs["contentNodeId"]);
    if (!fpwidget) {
        dojo.debug("building a new floating pane!");
        var floatingPaneNode = tacos.createFloatingPaneNodeIfNotExists(floatingPaneArgs);
        
        if (!contentNode) {
            dojo.debug("creating content node");
            contentNode = document.createElement("div");
            contentNode.setAttribute("id", floatingPaneArgs["contentNodeId"]);
			
            var contentClass = "tacosFloatingPaneContent";
            if(floatingPaneArgs["contentNodeClass"]){
                 contentClass = floatingPaneArgs["contentNodeClass"];
            }
            dojo.html.addClass(contentNode, contentClass);
        }else{
            dojo.dom.removeNode(contentNode);
        }
		
        floatingPaneNode.appendChild(contentNode);
        dojo.debug("creating new widget, building floating pane from script!");
        fpwidget = dojo.widget.fromScript("FloatingPane", floatingPaneArgs, floatingPaneNode);
		fpwidget.widgetId = floatingPaneArgs["widgetId"];
		
		//make sure widget id is being managed
		dojo.widget.widgetIds[fpwidget.widgetId] = fpwidget;
		
        if(floatingPaneArgs["persistenceWidgetPosition"]){
            tacos.initializeFloatingPane(floatingPaneArgs["widgetId"]);
        }
    }
	
    if(floatingPaneArgs["content"]){
        contentNode.innerHTML = floatingPaneArgs["content"];
        dojo.debug("content replaced!");
    }
    fpwidget.show();

}

//
//creating a FloatingPane if not exists.
//
tacos.createFloatingPaneNodeIfNotExists = function(floatingPaneArgs)
{
    var body = dojo.html.body();
	
    //creating target element if not exsits.
    var floatingPaneNode = dojo.byId(floatingPaneArgs["widgetId"]);
    if (!floatingPaneNode) {
        floatingPaneNode = document.createElement("div");
        floatingPaneNode.setAttribute("id", floatingPaneArgs["widgetId"]);
    }
	
    if (floatingPaneArgs["class"]) {
        dojo.html.setClass(floatingPaneNode, floatingPaneArgs["class"]);
    }else{
        var styleText = "width: 640px; height: 480px; left: 100px; top: 100px";
        if(floatingPaneArgs["style"]){
            styleText = floatingPaneArgs["style"];
        }
        floatingPaneNode.style.cssText = styleText;
    }
	
    body.appendChild(floatingPaneNode);
	
    return floatingPaneNode;
}

//
// initialize the given floating pane.
//
tacos.initializeFloatingPane = function(floatingPaneId)
{
    var fp_coords_left_cookie_key = "fp_" + floatingPaneId + "_coords_left";
    var fp_coords_top_cookie_key = "fp_" + floatingPaneId + "_coords_top";
    var fp_coords_width_cookie_key = "fp_" + floatingPaneId + "_coords_width";
    var fp_coords_height_cookie_key = "fp_" + floatingPaneId + "_coords_height";
    var fp_left = dojo.io.cookie.getCookie(fp_coords_left_cookie_key);
    var fp_top = dojo.io.cookie.getCookie(fp_coords_top_cookie_key);
    var fp_width = dojo.io.cookie.getCookie(fp_coords_width_cookie_key);
    var fp_height = dojo.io.cookie.getCookie(fp_coords_height_cookie_key);
	
    var fp = dojo.byId(floatingPaneId);
    var fpWidget = dojo.widget.byId(floatingPaneId);
    if (!fpWidget) {
        dojo.debug("NO Floating pane widget found with id:" + floatingPaneId);
        return;
    }
	
    try {
        dojo.debug("loading positions x,y,w,h:" + fp_left + "," 
       			  + fp_top + "," + fp_width + "," + fp_height);
        fpWidget.domNode.style.top = "40px";
        if (fp_left && fp_top)
        {
            fpWidget.domNode.style.left = fp_left;
            fpWidget.domNode.style.top = fp_top;
        }
        if (fp_width && fp_height)
        {
            //fpWidget.resizeTo(fp_width, fp_height);
            fpWidget.domNode.style.width = fp_width;
            fpWidget.domNode.style.height = fp_height;
        }
		
        //fpWidget.resizable = true;
        dojo.event.connect(fpWidget, "ondragend", function(evt)
        {
            var x = fpWidget.domNode.style.left;
            var y = fpWidget.domNode.style.top;
            dojo.io.cookie.setCookie(fp_coords_top_cookie_key, y, 60);
            dojo.io.cookie.setCookie(fp_coords_left_cookie_key, x, 60);
        });
		
        dojo.event.connect(fpWidget, "onResized", function(evt)
        {
            var w = fpWidget.domNode.style.width;
            var h = fpWidget.domNode.style.height;
            dojo.io.cookie.setCookie(fp_coords_width_cookie_key, w, 60);
            dojo.io.cookie.setCookie(fp_coords_height_cookie_key, h, 60);
        });
        
        dojo.event.connect(dojo.byId(floatingPaneId), "onclick", function(evt)
        {
        		dojo.debug("mouseclick");
        		var x = fpWidget.domNode.style.left;
            var y = fpWidget.domNode.style.top;
            dojo.io.cookie.setCookie(fp_coords_top_cookie_key, y, 60);
            dojo.io.cookie.setCookie(fp_coords_left_cookie_key, x, 60);	
        });
		
		fpWidget.resizeSoon();
		dojo.event.connect(fpWidget, "minimizeWindow", function(evt) {
			fpWidget.closeWindow();
		});
    } catch (e) {
        dojo.debug("ERROR initilizing floating pane with id:"
                + floatingPaneId + " " + e);
    }
}

//
// Used by Form.js to register forms a little differently
// than the tapestry default.
//
// formId - String unique id of form
//
tacos.registerForm = function(formId) {
  if (tacos.forms[formId]) delete tacos.forms[formId];
  tacos.forms[formId] = {};
  tacos.forms[formId]["form"] = dojo.byId(formId);
  tacos.forms[formId]["handlers"] = [];
}

//
// Called by Form.js on<event> methods to enable execution
// of validation/etc functions during a form post.
//
// formId - Unique form id
// handler - JS function to be called
//
tacos.addFormHandler = function(formId, handler) {
  if (!tacos.forms[formId]) return;
  tacos.forms[formId]["handlers"].push(handler);
}

//
// Executes the stored handlers for the specified form.
//
// formId - Unique form id
// event - Original javascript event that triggered the form
//		   submission.
//
tacos.applyFormHandlers = function(formId, event) {
  if (!tacos.forms[formId]) return;

  var handlers = tacos.forms[formId]["handlers"];
  for (var i=0; i < handlers.length; i++) {
    handlers[i].call(window, event);
  }
}

//
// Some dojo debug console logging ideas I'm playing with
//
dojo.infoDIV = document.createElement("span");
dojo.infoDIV.setAttribute("style", "font-weight:bold;color:#000000;");
dojo.infoDIV.appendChild(document.createTextNode("INFO:"));

dojo.info = function(info)
{
    try {
        var console = document.getElementById(djConfig.debugContainerId ?
                                              djConfig.debugContainerId : dojo.hostenv.defaultDebugContainerId);
        if (!console) {
            console = document.getElementsByTagName("body")[0] || document.body;
        }

        var div = document.createElement("div");
        div.setAttribute("style", "display:block; width:100%;"
                + "background:#BFE0F1;color:#000000;"
                + "border-top:1px solid #80C1E3;border-bottom:1px solid #80C1E3;");
        div.appendChild(dojo.infoDIV);
        div.appendChild(document.createTextNode(info));
        console.appendChild(div);
    } catch (e) {
        try {
            // safari needs the output wrapped in an element for some reason
            document.write("<div>INFO:" + info + "</div>");
        } catch(e2) {
            window.status = "INFO" + info;
        }
    }
}

function windowError(message, url, line)
{
    FVL_log('Error on line ' + line + ' of document ' + url + ': ' + message, FVL_FATAL);
    return true;
    //
}

// only override the window's error handler if we logging is turned on
if (djConfig["isDebug"]) {
    dojo.event.connect(window, "onerror", function(msg, url, line)
    {
        dojo.debug("ERROR: On line " + line + " of document " + url
                + ": " + msg);
    });
}